
ents = {}
ents.objects = {} -- contains active objects
ents.objpath = "entities/"

local register = {} -- register templates for each entity
local id = 0 -- unique ID for each entity (increases by +1 each time)


function ents.Startup()

	register["dummy"]		= love.filesystem.load(ents.objpath .. "char_dummy.lua")  -- training dummy
	register["sol"]			= love.filesystem.load(ents.objpath .. "char_sol.lua")
--	register["ky"]			= love.filesystem.load(ents.objpath .. "char_ky.lua")

end


function ents.Derive(name)
	return love.filesystem.load(ents.objpath .. name .. ".lua")() -- Derive's from base.lua (top of each new entity.lua)
end


function ents.Create(name, x, y)

	if not x then
		print("ents.Create: NO X VALUE - setting to 512")
		x = 512
	end

	if not y then
		print("ents.Create: NO Y VALUE - setting to 0")
		y = 0
	end

	if register[name] then
		id = id + 1 -- each time entity is created, id +1
		local ent = register[name]()
		ent:load()
		ent:setPos(x, y)
		ent.id = id
		ents.objects[#ents.objects +1] = ent
		return ents.objects[#ents.objects]


	else
		print("Error: Entity " .. name .. " does not exist!")
		return false;
	end
end


function ents:update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end


function ents:draw()
	for i, ent in pairs(ents.objects) do
		if ent.draw then
			ent:draw()
		end
	end
end
